--- vorbis.0.c	2008-05-23 18:44:20.000000000 -0400
+++ vorbis.c	2009-03-02 01:51:28.000000000 -0500
@@ -120,6 +120,7 @@
 
 static GThread *thread;
 static volatile int seekneeded = -1;
+static volatile char pause_flag;
 static int samplerate, channels;
 GMutex *vf_mutex;
 
@@ -228,6 +229,16 @@
     }
 }
 
+static void do_pause (InputPlayback * playback) {
+   playback->output->pause (1);
+   while (pause_flag) {
+      if (seekneeded != -1)
+         do_seek (playback);
+      g_usleep(50000);
+   }
+   playback->output->pause (0);
+}
+
 #define PCM_FRAMES 1024
 #define PCM_BUFSIZE PCM_FRAMES*2
 
@@ -338,6 +349,8 @@
 
         if (seekneeded != -1)
             do_seek(playback);
+        if (pause_flag)
+            do_pause (playback);
 
         
         int current_section = last_section;
@@ -488,7 +501,7 @@
 static void
 vorbis_pause(InputPlayback *playback, short p)
 {
-    playback->output->pause(p);
+    pause_flag = p;
 }
 
 static void
